// version pour  carte Clic 18F47J53
// rev 21-12-2015
//#define With_UART    uart non utilise
//#define EXTRA_char
/*
LDC  2x16car  Controleur PCF 2119   I2C
LCD DISPLAY MODULE PHICO D-0 0002 94V-0 P71-3 NEW
MC21605E6W-SPTLYI - MIDAS - LCD 2X16 STN LED B/L Y/VERT I2C I/F
          /
Port D  I2C2
   RD0  SCL2
   RD1  SDA2
   sur clik mikrobus   (PIC18F47J53)

*/


extern char LCD_ADR;
extern void Decompile_byte(unsigned char un);
extern char *txt;

void LCD_CLS(void);
void LCD_Clear(void); // <-- PB >> au lieu de space..  suivre
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_at(int Ligne,int Col,char c1) ;
void LCD_Write_Chr(unsigned char cx);
void LCD_Write_Text(unsigned int Ligne,unsigned char * t1);
void LCD_Write_CText(unsigned int Ligne,unsigned int col,const char * t1);

void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void)  ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);
 // necessite liaison RS232 UARTx
//unsigned char check_device(unsigned char dev_address);



void LCD_Write_Chr(unsigned char cx)
{
     I2C2_Start();
     I2C2_Wr(LCD_ADR); // i2c slave Address
     I2C2_Wr(0x40);
     I2C2_Wr( 0x80 + cx );    // criture de la lettre ou pointe le pointeur
     I2C2_Stop();
}

void LCD_Write_CGRAM_Chr(unsigned char cx)
{
     I2C2_Start();
     I2C2_Wr(LCD_ADR); // i2c slave Address
     I2C2_Wr(0x40);
     I2C2_Wr( 0x00 + cx );    // criture de la lettre ou pointe le pointeur
     I2C2_Stop();
}


// *** LCD 2119 ***********
void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}


void LCD_Clear()
{
 // problematique car CGM type R
int j;
I2C2_Start();
j=I2C2_Wr(LCD_ADR); // i2c slave Address
j=I2C2_Wr(0x00);
j=I2C2_Wr(0x24);
j=I2C2_Wr(0x06);
j=I2C2_Wr(0x02);
j=I2C2_Wr(0x01);
j=I2C2_Wr(0x40);
I2C2_Stop();
}

int LCD2119_Init(void)
{
// see datasheet PCF2119x NXP Semiconductorspage 69
int j,k;
k=0;
Delay_ms(500);
I2C2_Start();
j=I2C2_Wr(LCD_ADR); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2C2_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2C2_Wr(0x24); //0x20 +  DL=0 format 4 ou 8 bits not used, M=1 car 2x16 cars display, SL=0 1:18, H: mode standard
I2C2_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2C2_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
I2C2_Wr(0x25); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C2_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2C2_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2C2_Wr(0x11); // TC1: 0, TC0: 1
I2C2_Wr(0x42); // HV Stages 3
//I2C2_Wr(0x9f); // set Vlcd, store to VA
I2C2_Wr(0x96); // set Vlcd, store to VA  (avec alim=3,3V)
j=I2C2_Wr(0x24); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2C2_Wr(0x0C);
if (j>0) return k;
k++;
j=I2C2_Wr(0x06);
if (j>0) return k;
k++;
j=I2C2_Wr(0x02); // return home
if (j>0) return k;
k++;
// avec LC2119 RU  remplissage avec caractere >> au lieu de blanc=espace
/// il faut un modele LCD2119 AU  !
j=I2C2_Wr(0x01); // clear display
if (j>0) return k;
Delay_ms(100);
I2C2_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{
int i;
 I2C2_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Address
 I2C2_Wr(0x00); // Control byte for Instruction
 I2C2_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2C2_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40);     // Control byte for Data
 for (i=0;i<39;i++)
 {
   I2C2_Wr(0x80+32); // efface avec des blanc
 }
 // repositionne au debut de ligne
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x00); // Control byte for Instruction
 //I2C2_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2C2_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2C2_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2C2_Stop();
}

void LCD_Write_CText(unsigned int Ligne,unsigned int col,const unsigned char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C2_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
 {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
        break;
  default:
  break ;
 }
 I2C2_Repeated_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C2_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C2_Stop();
}

void LCD_Write_Chr_at(int Ligne,int col,unsigned char c1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  // .. Special =0 pour ascii normal   1 pour caracteres perso definis en CGRAM
  I2C2_Start() ;
  I2C2_Wr(LCD_ADR); // i2c slave Adress
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C2_Repeated_Start();       // Rptition de l'ouverture de la com I2C
  I2C2_Wr(LCD_ADR);            // Envoi de l'adresse esclave
  I2C2_Wr(0x40);               // Byte de contrle pour envoyer une DATA
  I2C2_Wr( 0x80 + c1 );    // criture de la lettre ou pointe le pointeur
  Delay_ms(10);                      // Pause de 10ms
  I2C1_Stop();                        // Fin de l'I2C
 }


void LCD_Write_Text(unsigned int Ligne,unsigned int col,unsigned char * t1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  int i;
  I2C2_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Address
  I2C2_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C2_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C2_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C2_Repeated_Start();
  I2C2_Wr(LCD_ADR); // i2c slave Adress
  I2C2_Wr(0x40); // Control byte for Data
  i=0;
  while(*(t1))
  {
  I2C2_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
  }
  I2C2_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
  LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C2_Start();
 I2C2_Wr(LCD_ADR); //Display adress
 I2C2_Wr(0x00); //Register Select Config Register
 I2C2_Wr(Cde); //Write Data
 I2C2_Stop();
}

void LCD_Gauche()
{
  LCD_Cde(0x010);
 }


#ifdef EXTRA_char
void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
 I2C2_Start();
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x00);
 // Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
 I2C2_Wr(0x40);
// I2C2_Start();
 I2C2_Repeated_Start() ;
 I2C2_Wr(LCD_ADR); // i2c slave Adress
 I2C2_Wr(0x40);// set CGRAM adress

 //Probleme : 5 pixels seulement accessibles en largeur (sur 8)
// blanc
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
/*
  b2=32;
  b1=0;
  for (i=0;i<5;i++)
  {
   b2=b2>>1;
   b1=b1+b2;
   for (j=0;j<8;j++)
   {
   #ifdef With_UART
     UART1_Write_CText("I2C2_Wr(");
     Decompile_byte(b1);
     CRLF1();
     #endif
     I2C2_Wr(b1);

   }
   #ifdef With_UART
    CRLF1();
    #endif
  }
 */
  // petit rectangle
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0011111);
I2C2_Wr(0b0010001);
I2C2_Wr(0b0011111);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
I2C2_Wr(0b0000000);
// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C2_Wr(0x06); // 00110
I2C2_Wr(0x09); // 01001
I2C2_Wr(0x08); // 01000
I2C2_Wr(0x1E); // 11110
I2C2_Wr(0x1E); // 11110
I2C2_Wr(0x08); // 01000
I2C2_Wr(0x09); // 01001
I2C2_Wr(0x06); // 00110
//
//*C
I2C2_Wr(0x07); // 00111
I2C2_Wr(0x05); // 00101
I2C2_Wr(0x07); // 00111
I2C2_Wr(0x00); // 00000
I2C2_Wr(0x0E); // 01110
I2C2_Wr(0x10); // 10000
I2C2_Wr(0x10); // 10000
I2C2_Wr(0x0E); // 01110

I2C2_Stop();
}


void Cree_Euro()
{
I2C2_Start();
// PCF2119 slave address for write, SA0 is connected to Vdd
I2C2_Wr(LCD_ADR); // i2c slave Adress
// MSB (Continuation bit Co) = 0, more than one byte may follow. Bit6, RS=0, next byte
// is command byte
I2C2_Wr(0x00);
// 2 lines x 16, 1/18 duty, basic instruction set. Next byte will be another command.
//I2C2_Wr(0x24);
I2C2_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
//I2C2_Wr(0xC0);  // DDRam adresse remark page 35
// Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
I2C2_Wr(0x40);
//I2C2_Stop();
// Repeated Start condition
 I2C2_Repeated_Start() ;
I2C2_Wr(LCD_ADR); // i2c slave Adress
// RS=1, next byte is a data byte
I2C2_Wr(0x40);// set CGRAM adress
// Here the data bytes to define the character
// Behind the write commands the 5x8 dot matrix is shown, the 1 represents a on pixel.
// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C2_Wr(0x06); // 00110
I2C2_Wr(0x09); // 01001
I2C2_Wr(0x08); // 01000
I2C2_Wr(0x1E); // 11110
I2C2_Wr(0x1E); // 11110
I2C2_Wr(0x08); // 01000
I2C2_Wr(0x09); // 01001
I2C2_Wr(0x06); // 00110
I2C2_Stop();
}


void Cree_DegreC()
{
I2C2_Start();
I2C2_Wr(LCD_ADR); // i2c slave Adress
I2C2_Wr(0x00);
I2C2_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
I2C2_Wr(0x40);
I2C2_Repeated_Start() ;
I2C2_Wr(LCD_ADR);
I2C2_Wr(0x40);// set CGRAM adress
I2C2_Wr(0x07); // 00111
I2C2_Wr(0x05); // 00101
I2C2_Wr(0x07); // 00111
I2C2_Wr(0x00); // 00000
I2C2_Wr(0x0E); // 01110
I2C2_Wr(0x10); // 10000
I2C2_Wr(0x10); // 10000
I2C2_Wr(0x0E); // 01110
I2C2_Stop();
}
#endif